export interface libsodiumSymbolIO {
    name: string;
    optional?: boolean;
    size?: string;
    type: string;
}
export interface libsodiumSymbol {
    assert_retval?: [{
        condition: string;
        or_else_throw: string;
    }];
    dependencies?: Array<string>;
    inputs?: Array<libsodiumSymbolIO>;
    name: string;
    noOutputFormat?: boolean;
    outputs?: Array<libsodiumSymbolIO>;
    return?: string;
    target?: string;
    type: 'function';
}
export default class TypeGenerator {
    outputFile: string;
    private libsodiumLocalSource;
    private constants;
    private libsodiumVersion;
    private externalLibsodiumSource;
    private sourceIsSet;
    private additionalSymbols;
    private enums;
    private genericTypes;
    private types;
    constructor(outputFile: string, libsodiumLocalSource?: string);
    setDownloadVersion(version: string): Promise<TypeGenerator>;
    private downloadLibrary();
    getVersion(): string;
    private getFunctions();
    private getConstants();
    private convertType(type);
    private convertReturnType(type);
    private buildData();
    generate(): Promise<string>;
}
